<template>
    <section>
        <span style="float: right; position: relative"><router-link to="/advertiser/my-ads/new" class="font-weight-bold h5 mb-0"><i class="far fa-plus-square"></i> NEW</router-link> </span>

        <h2>My Ads</h2>

        <br>

        <!--<form class="form-inline">
            <label class="sr-only" for="searchInput">Search</label>
            <input type="text" class="form-control mb-2 mr-sm-2 w-100" id="searchInput" placeholder="Search">

            <button type="submit" class="btn btn-primary mb-2">Search</button>
        </form>-->

        <template v-if="loading || fail">
            <div class="text-center m-5 p-5">
                <span class="h2" v-if="loading"><i class="fas fa-spinner fa-spin"></i></span>
                <span v-else-if="fail">
                    {{ fail.message }}
                    <br><a href="#" class="btn btn-outline-primary" v-on:click.prevent="loadContents">Retry</a>
                </span>
            </div>
        </template>
        <div class="row mx-auto" v-else>

            <div class="col-md-4 p-1" v-for="ad in ads">
                <div class="card bg-transparent " style="min-height: 8rem;">
                    <div class="card-body">
                        <span class="card-title h4">{{ ad.name }}</span>
                    </div>

                    <div class="card-footer bg-transparent">
                        <router-link v-bind:to="'/advertiser/my-ads/' + ad.id" class="my-0 float-right">Manage</router-link>
                    </div>

                </div>
            </div>

            <!--<div class="col-md-4 p-1">
                <div class="card bg-transparent " style="min-height: 8rem;">
                    <div class="card-body">
                        <span class="card-title h4">TA Concert</span>
                    </div>

                    <div class="card-footer bg-transparent">
                        <a href="#" class="my-0 float-right">Manage</a>
                    </div>

                </div>
            </div>

            <div class="col-md-4 p-1">
                <div class="card bg-transparent " style="min-height: 8rem;">
                    <div class="card-body">
                        <span class="card-title h4">Anbessa Promo</span>
                    </div>

                    <div class="card-footer bg-transparent">
                        <a href="#" class="my-0 float-right">Manage</a>
                    </div>

                </div>
            </div>

            <div class="col-md-4 p-1">
                <div class="card bg-transparent " style="min-height: 8rem;">
                    <div class="card-body">
                        <span class="card-title h4">Push</span>
                    </div>

                    <div class="card-footer bg-transparent">
                        <a href="#" class="my-0 float-right">Manage</a>
                    </div>

                </div>
            </div>

            <div class="col-md-4 p-1">
                <div class="card bg-transparent " style="min-height: 8rem;">
                    <div class="card-body">
                        <span class="card-title h4">Sample Ad</span>
                    </div>

                    <div class="card-footer bg-transparent">
                        <a href="#" class="my-0 float-right">Manage</a>
                    </div>

                </div>
            </div>-->
        </div>
    </section>
</template>

<script>
    export default {
        data: function () {
            return {
                // Ads
                ads: null,


                // Loading flag
                loading: false,

                // Fail flag
                fail: false,
            }
        },
        methods: {
            loadAds: function () {
                // Show the loading
                this.loading = true;

                // Clear previous flags
                this.fail = false;

                // Make a request to the server
                axios.get('/api/advertiser/ads')
                    .then(response => {
                        this.ads = response.data;
                    })
                    .catch(error => {
                        if (error.response) {
                            // The request was made and the server responded with a status code
                            // that falls out of the range of 2xx
                            console.log(error.response.status);

                            // Handle validation errors
                            if (error.response.status === 401) {
                                this.fail = {
                                    'message': 'Unauthorized'
                                };
                            } else {
                                this.fail = {
                                    message: 'Something Went Wrong. Check your connection and try again.'
                                };
                            }

                        } else if (error.request) {
                            // The request was made, but no response was received
                            console.log(error.request);

                            this.fail = {
                                message: 'Something Went Wrong. Check your connection and try again.'
                            };

                        } else {
                            // Something happened in setting up the request that triggered an error
                            console.log('Error', error.message);

                            this.fail = {
                                message: 'Something Went Wrong. Check your connection and try again.'
                            };
                        }
                    })
                    .then(e => {
                        // Hide the loading
                        this.loading = false;
                    })
            }
        },
        mounted() {
            // Load the ads
            this.loadAds();

            console.log('Advertiser - My Ads mounted.')
        }
    }
</script>
